Index: lemon/bits/bezier.h
===================================================================
--- lemon/bits/bezier.h	(revision 2553)
+++ lemon/bits/bezier.h	(revision 2618)
@@ -35,5 +35,5 @@
 class BezierBase {
 public:
-  typedef Point<double> Point;
+  typedef lemon::dim2::Point<double> Point;
 protected:
   static Point conv(Point x,Point y,double t) {return (1-t)*x+t*y;}
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 2553)
+++ lemon/bits/traits.h	(revision 2618)
@@ -225,6 +225,6 @@
     typedef typename Map::Value Value;
 
-    typedef const Value ConstReturnValue;
-    typedef const Value ReturnValue;
+    typedef Value ConstReturnValue;
+    typedef Value ReturnValue;
   };
 
@@ -253,6 +253,6 @@
     typedef typename MatrixMap::Value Value;
 
-    typedef const Value ConstReturnValue;
-    typedef const Value ReturnValue;
+    typedef Value ConstReturnValue;
+    typedef Value ReturnValue;
   };
 
Index: lemon/circulation.h
===================================================================
--- lemon/circulation.h	(revision 2553)
+++ lemon/circulation.h	(revision 2618)
@@ -89,5 +89,5 @@
     /// \sa Elevator
     /// \sa LinkedElevator
-    typedef Elevator<Graph, typename Graph::Node> Elevator;
+    typedef lemon::Elevator<Graph, typename Graph::Node> Elevator;
     
     /// \brief Instantiates an Elevator.
@@ -103,5 +103,5 @@
     ///
     /// The tolerance used by the algorithm to handle inexact computation.
-    typedef Tolerance<Value> Tolerance;
+    typedef lemon::Tolerance<Value> Tolerance;
 
   };
Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 2553)
+++ lemon/dijkstra.h	(revision 2618)
@@ -31,4 +31,6 @@
 #include <lemon/error.h>
 #include <lemon/maps.h>
+
+#include <limits>
 
 
Index: lemon/edge_set.h
===================================================================
--- lemon/edge_set.h	(revision 2553)
+++ lemon/edge_set.h	(revision 2618)
@@ -155,5 +155,5 @@
       Node node;
       for (first(node); node != INVALID && (*nodes)[node].first_in == -1; 
-	   next(node));
+	   next(node)) { }
       edge.id = (node == INVALID) ? -1 : (*nodes)[node].first_in;
     }
@@ -165,5 +165,5 @@
 	Node node = edges[edge.id].target;
 	for (next(node); node != INVALID && (*nodes)[node].first_in == -1; 
-	     next(node));
+	     next(node)) { }
 	edge.id = (node == INVALID) ? -1 : (*nodes)[node].first_in;
       }      
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 2569)
+++ lemon/graph_to_eps.h	(revision 2618)
@@ -1002,5 +1002,5 @@
       else for(EdgeIt e(g);e!=INVALID;++e)
 	if((!_undirected||g.source(e)<g.target(e))&&_edgeWidths[e]>0
-	   &&g.source(e)!=g.target(e))
+	   &&g.source(e)!=g.target(e)) {
 	  if(_drawArrows) {
 	    dim2::Point<double> d(mycoords[g.target(e)]-mycoords[g.source(e)]);
@@ -1031,4 +1031,5 @@
 		  << _edgeColors[e].blue() << ' '
 		  << _edgeWidths[e]*_edgeWidthScale << " l\n";
+	}
       os << "grestore\n";
     }
Index: lemon/lemon_reader.h
===================================================================
--- lemon/lemon_reader.h	(revision 2553)
+++ lemon/lemon_reader.h	(revision 2618)
@@ -3473,5 +3473,5 @@
 	maps.push_back(name);
       }
-      while (getline(is, line));
+      while (getline(is, line)) { }
     }
 
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 2553)
+++ lemon/list_graph.h	(revision 2618)
@@ -119,5 +119,5 @@
       for(n = first_node; 
 	  n!=-1 && nodes[n].first_in == -1; 
-	  n = nodes[n].next);
+	  n = nodes[n].next) { }
       e.id = (n == -1) ? -1 : nodes[n].first_in;
     }
@@ -129,6 +129,6 @@
 	int n;
 	for(n = nodes[edges[edge.id].target].next;
-	  n!=-1 && nodes[n].first_in == -1; 
-	  n = nodes[n].next);
+	    n!=-1 && nodes[n].first_in == -1; 
+	    n = nodes[n].next) { }
 	edge.id = (n == -1) ? -1 : nodes[n].first_in;
       }      
Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 2609)
+++ lemon/lp_base.h	(revision 2618)
@@ -44,7 +44,7 @@
   {
     typedef std::numeric_limits<T> Lim;
-    if (Lim::has_infinity && (value == Lim::infinity() || value ==
-          -Lim::infinity()) ||
-        (Lim::has_quiet_NaN || Lim::has_signaling_NaN) && value != value)
+    if ((Lim::has_infinity && (value == Lim::infinity() || value ==
+			       -Lim::infinity())) ||
+        ((Lim::has_quiet_NaN || Lim::has_signaling_NaN) && value != value))
     {
       return false;
Index: lemon/min_mean_cycle.h
===================================================================
--- lemon/min_mean_cycle.h	(revision 2588)
+++ lemon/min_mean_cycle.h	(revision 2618)
@@ -56,5 +56,5 @@
 
     typedef typename LengthMap::Value Length;
-    typedef Path<Graph> Path;
+    typedef lemon::Path<Graph> Path;
 
   private:
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 2553)
+++ lemon/preflow.h	(revision 2618)
@@ -87,5 +87,5 @@
     ///
     /// The tolerance used by the algorithm to handle inexact computation.
-    typedef Tolerance<Value> Tolerance;
+    typedef lemon::Tolerance<Value> Tolerance;
 
   };
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 2608)
+++ lemon/random.h	(revision 2618)
@@ -68,4 +68,5 @@
 
 #include <ctime>
+#include <limits>
 
 #include <lemon/math.h>