Index: lemon/cycle_canceling.h
===================================================================
--- lemon/cycle_canceling.h	(revision 2593)
+++ lemon/cycle_canceling.h	(revision 2620)
@@ -65,5 +65,4 @@
   ///
   /// \author Peter Kovacs
-
   template < typename Graph,
              typename LowerMap = typename Graph::template EdgeMap<int>,
@@ -99,6 +98,5 @@
     /// \brief Map adaptor class for handling residual edge costs.
     ///
-    /// \ref ResidualCostMap is a map adaptor class for handling
-    /// residual edge costs.
+    /// Map adaptor class for handling residual edge costs.
     class ResidualCostMap : public MapBase<ResEdge, Cost>
     {
@@ -279,7 +277,7 @@
     }
 
-    /// \brief Sets the flow map.
-    ///
-    /// Sets the flow map.
+    /// \brief Set the flow map.
+    ///
+    /// Set the flow map.
     ///
     /// \return \c (*this)
@@ -293,7 +291,7 @@
     }
 
-    /// \brief Sets the potential map.
-    ///
-    /// Sets the potential map.
+    /// \brief Set the potential map.
+    ///
+    /// Set the potential map.
     ///
     /// \return \c (*this)
@@ -308,12 +306,10 @@
 
     /// \name Execution control
-    /// The only way to execute the algorithm is to call the run()
-    /// function.
 
     /// @{
 
-    /// \brief Runs the algorithm.
-    ///
-    /// Runs the algorithm.
+    /// \brief Run the algorithm.
+    ///
+    /// Run the algorithm.
     ///
     /// \param min_mean_cc Set this parameter to \c true to run the
@@ -330,13 +326,14 @@
     /// \name Query Functions
     /// The result of the algorithm can be obtained using these
-    /// functions.
-    /// \n run() must be called before using them.
+    /// functions.\n
+    /// \ref lemon::CycleCanceling::run() "run()" must be called before
+    /// using them.
 
     /// @{
 
-    /// \brief Returns a const reference to the edge map storing the
+    /// \brief Return a const reference to the edge map storing the
     /// found flow.
     ///
-    /// Returns a const reference to the edge map storing the found flow.
+    /// Return a const reference to the edge map storing the found flow.
     ///
     /// \pre \ref run() must be called before using this function.
@@ -345,8 +342,8 @@
     }
 
-    /// \brief Returns a const reference to the node map storing the
+    /// \brief Return a const reference to the node map storing the
     /// found potentials (the dual solution).
     ///
-    /// Returns a const reference to the node map storing the found
+    /// Return a const reference to the node map storing the found
     /// potentials (the dual solution).
     ///
@@ -356,7 +353,7 @@
     }
 
-    /// \brief Returns the flow on the given edge.
-    ///
-    /// Returns the flow on the given edge.
+    /// \brief Return the flow on the given edge.
+    ///
+    /// Return the flow on the given edge.
     ///
     /// \pre \ref run() must be called before using this function.
@@ -365,7 +362,7 @@
     }
 
-    /// \brief Returns the potential of the given node.
-    ///
-    /// Returns the potential of the given node.
+    /// \brief Return the potential of the given node.
+    ///
+    /// Return the potential of the given node.
     ///
     /// \pre \ref run() must be called before using this function.
@@ -374,7 +371,7 @@
     }
 
-    /// \brief Returns the total cost of the found flow.
-    ///
-    /// Returns the total cost of the found flow. The complexity of the
+    /// \brief Return the total cost of the found flow.
+    ///
+    /// Return the total cost of the found flow. The complexity of the
     /// function is \f$ O(e) \f$.
     ///
@@ -391,5 +388,5 @@
   private:
 
-    /// Initializes the algorithm.
+    /// Initialize the algorithm.
     bool init() {
       if (!_valid_supply) return false;
@@ -429,7 +426,7 @@
     }
 
-    /// \brief Executes the algorithm using \ref BellmanFord.
-    ///
-    /// Executes the algorithm using the \ref BellmanFord
+    /// \brief Execute the algorithm using \ref BellmanFord.
+    ///
+    /// Execute the algorithm using the \ref BellmanFord
     /// "Bellman-Ford" algorithm for negative cycle detection with
     /// successively larger limit for the number of iterations.
@@ -507,7 +504,7 @@
     }
 
-    /// \brief Executes the algorithm using \ref MinMeanCycle.
-    ///
-    /// Executes the algorithm using \ref MinMeanCycle for negative
+    /// \brief Execute the algorithm using \ref MinMeanCycle.
+    ///
+    /// Execute the algorithm using \ref MinMeanCycle for negative
     /// cycle detection.
     void startMinMean() {